function load(url) {
  var result = new Promise((resolve, reject) => {
    var xhr = new XMLHttpRequest();
    xhr.open("GET", url);
    xhr.onload = function (e) {
      resolve(this.responseText);
    };
    xhr.onerror = (e) => {
      console.error(e);
      reject(e);
    };
    xhr.send();
  });
  return result;
}

function init() {
  const template = load("/assets/template.html").then((templateHtml) => {
    load("uidata.json").then((modelJson) => {
      const model = { data: JSON.parse(modelJson) };
      const template = Handlebars.compile(templateHtml);
      const html = template(model);
      $("#template").replaceWith(html);
      const mitidClient = load("mitid-client.html").then((html) => {
        $("#mitid-client").html(html);
      });
    });
  });
}
