# MitID branding files

## Special containers and classes

- container with id="mitid-client" is used to generate mitid UI widget inside
- containers showing errors have "error" class
- there are 3 kind of errors therefore 3 containers
  - "failure" is used to show API call error. Makes sense to show with the following buttons:
     - Retry ("js-failure-retry") - re-sends the failed call to server
     - Close ("js-close") - redirect user to the error url
  - "mitid-error" is used when mitid reported problem (or when mitid widget is failed to initialize at all). The following buttons are relevant:
     - Reload ("js-reload") - reload the browser page
     - Close ("js-close") - redirect to the error url
  - "template-error" is used when something wrong in template configuration. For instance when redirect urls is not set

  When "js-close" button is missed the user interaction part is skipped and user is automatically redirected to the error url

## Binding 
There is a `uidata` parameter driving the data source for binding. It can be set on the global level (where the predefined `document.title` comes from), merchant settings level or request level. All these objects are merged 
and then sent to the template as a data source. The pre-defined `document.title` field is automatically bound to the page title, the rest is under the template author's control

```
{
  "document": {
    "title": "ZignSec Verifications - mitID"
  }
}

```

[Handlebars](https://handlebarsjs.com/) is used for binding data in templates. 

```
    <h1>{{data.document.title}}</h1>
```

### Localization
`uidata` can be localized, to define translations for language add `l10n` field, then use the property name inside as a 2-letter language code, and the value will contain translations. It's merged with the root level values, so it's ok to only fill changes

```
{
  "document": {
    "title": "ZignSec Verifications - mitID"
  },
  "errors": {
    "apiCallFailed": "Something went wrong calling our API"
  },
  "buttons": {
    "close": {
      "text": "X",
      "title": "Close"
    }
  }, 
  "l10n": {
    "da": {
      "errors": {
        "apiCallFailed": "Noget gik galt med at kalde vores API"
      },
      "buttons": {
        "close": {
          "title": "Lukke"
        }
      }
    }
  }
}

```

## The flow
See [the diagram]("MitId - flows.drawio")

## Testing

PRE-Requisite: `npm install` is called on the root folder (where `package.json` is located)

- .\serve betfair --no-open --port 9000
- .\serve betfair-simple --no-open --port 9001
- .\serve demo --no-open --port 9002
- .\serve demo2 --no-open --port 9003
- .\serve demo-min --no-open --port 9004

- .\serve betfair --port 9000
- .\serve betfair-simple --port 9001
- .\serve demo --port 9002
- .\serve demo2 --port 9003
- .\serve demo-min --port 9004